import 'package:flutter/material.dart';
import 'package:login_screen/bottomnavigationbar/page1.dart';
import 'package:login_screen/bottomnavigationbar/page2.dart';
import 'package:login_screen/bottomnavigationbar/page3.dart';
import 'package:login_screen/bottomnavigationbar/page4.dart';
import 'package:login_screen/bottomnavigationbar/page5.dart';

class NavBar5 extends StatefulWidget {
  const NavBar5({Key? key}) : super(key: key);
  @override
  State<NavBar5> createState() => _NavBar5State();
}
class _NavBar5State extends State<NavBar5> {
  double length=0;
  double y=0;
  int _selectedIndex = 0;
  List pages = [
    const Page1(),
    const Page2(),
    const Page3(),
    const Page4(),
    const Page5(),
  ];
  List labels=[
    'Home',
    'Message',
    'Cart',
    'Profile'
  ];
  List icon=[
    Icons.home,
    Icons.message,
    Icons.shopping_cart,
    Icons.person
  ];

  @override
  Widget build(BuildContext context) {
    Size screenSize = MediaQuery.of(context).size;
    const myColor=Colors.deepOrange;
    return Scaffold(
      extendBody: true,
      backgroundColor: Colors.yellow,
      body: pages[_selectedIndex],
      bottomNavigationBar: Stack(
        alignment: Alignment.bottomCenter, // Align children to the bottom of the Stack
        children: [
          ClipPath(
            clipper: MyClipper(x: length),
            child: Container(
              height: screenSize.height * 0.067,
              width: screenSize.width,
              color: myColor,
            ),
          ),
          Row(
            children: List.generate(
              labels.length,
                  (index) {
                return GestureDetector(
                  onTap: () {
                    setState(() {
                      _selectedIndex = index;
                      length = screenSize.width * 0.25 * index;
                    });
                  },
                  child: AnimatedContainer(
                    color: Colors.transparent,
                    height: 82,
                    alignment: Alignment.bottomCenter,
                    duration: const Duration(milliseconds: 200),
                    width: screenSize.width * 0.25,
                    padding: EdgeInsets.only(bottom: _selectedIndex == index ? 30 :5),
                    child: Column(
                      // mainAxisSize: MainAxisSize.min,
                       mainAxisAlignment: MainAxisAlignment.end, // Vertically center-align the children
                      children: [
                        Icon(
                          icon[index],
                          color: _selectedIndex == index ? myColor : Colors.white,
                          size: _selectedIndex == index ?35:25,
                        ),
                        Visibility(
                          visible: _selectedIndex!=index,
                          child: Text(
                            '${labels[index]}',
                            style: TextStyle(
                              color: Colors.white ,
                            ),
                          ),
                        )
                      ],
                    ),
                  ),
                );
              },
            ),
          ),
        ],
      ),
    );





  }


}

class MyClipper extends CustomClipper<Path>{
  double x=0;

   MyClipper({required this.x }) ;

  @override
  Path getClip(Size size) {
    Path path =Path();
    path.moveTo(0+x, 0);
    path.quadraticBezierTo(size.width*.04+x, 0, size.width*.06+x, size.height*.25);
    path.quadraticBezierTo(size.width*.08+x, size.height*.5, size.width*.12+x, size.height*.5);
    path.quadraticBezierTo(size.width*.16+x, size.height*.5, size.width*.18+x, size.height*.25);
    path.quadraticBezierTo(size.width*.20+x, 0, size.width*.24+x, 0);
    path.lineTo(size.width, 0);
    path.lineTo(size.width, size.height);
    path.lineTo(0, size.height);
    path.lineTo(0, 0);
    return path;
  }

  @override
  bool shouldReclip(covariant CustomClipper<Path> oldClipper) {

    return true;
  }

}
